#!/bin/sh
# the next line restarts using wish \
exec wish "$0" "$@"

#    Tkeca is a Tcl/Tk frontend for Kai Vehmanen's Ecasound
#    Copyright (C) 2002-2003  Luis Pablo Gasparotto
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#    To contact me: luispa8@yahoo.com.ar	

proc wave_files {} {
    global mfe bgcolor2 bgcolor track_num w3 w4 track_num2 n add_file
    if {$mfe(files$track_num) > 0} {set add_file 0}
    set track_num2 0
    if {[winfo exists .wave_files$track_num] != 0} {destroy .wave_files$track_num}
    toplevel .wave_files$track_num  -bd 6 -bg $bgcolor
    set w3 .wave_files$track_num
    frame $w3.buttons -bd 6 -bg $bgcolor
    label $w3.title -bg $bgcolor -text "Wave Files for Track $track_num"
    button $w3.buttons.add_file -bg AntiqueWhite -activebackground LightPink -text "Add Wave File" -command "
    set track_num2 $track_num
    set w3 .wave_files$track_num
    set w4 $w3.canvas.f
    set add_file 1
    add_wave_files"
    button $w3.buttons.close -bg AntiqueWhite -activebackground LightPink -text "Close" -command "destroy $w3"
    pack $w3.title
    pack $w3.buttons.add_file  -side left -fill both -expand 1
    pack $w3.buttons.close -side left -fill both -expand 1
    pack $w3.buttons -in $w3  -fill x -expand 1
    label $w3.label -bg $bgcolor -text "File                 Start  Length  Play/Rec          "
    pack $w3.label
    canvas $w3.canvas -bg $bgcolor2 -width 350 -height 100 -yscrollcommand [list $w3.yscroll set]
    $w3.canvas config -scrollregion "0 0 0 27"
    scrollbar $w3.yscroll -orient vertical -width 8 -command [list $w3.canvas yview]
    pack $w3.yscroll -side right -fill y -expand 1
    pack $w3.canvas -side left -fill y -expand 1
    set w4 [frame $w3.canvas.f -bd 0 ]
    $w3.canvas create window 0 0 -anchor nw -window $w4
    if {$mfe(files$track_num) > 0} {
	for {set nf 0} {$nf < $mfe(files$track_num)} {incr nf} {
	    set track_num2 $track_num
	    set w3 .wave_files$track_num
	    set w4 $w3.canvas.f
	    set n [expr $nf+1]
	    add_wave_files
	}
    }	
}

proc add_wave_files {} {
    global mfe w3 w4 mt_font track_num track_num2 bgcolor3 n add_file
    set track "track"
    set pointer "file$n$track$track_num2"
    if {$add_file == 1} {
	set mfe(files$track_num2) [expr $mfe(files$track_num2)+1]
	set n $mfe(files$track_num2) 
	set pointer "file$n$track$track_num2"
	set mfe(start1$pointer) 0
	set mfe(start2$pointer) 0
    }
    $w3.canvas config -scrollregion "0 0 0 [expr $n *26]"

    	entry $w4.entry1_$n -bg White -font $mt_font -width 15 -textvariable mfe($pointer)
	button $w4.open$n -bg LightPink2 -activebackground LightSeaGreen -font $mt_font -text ... -command "
	set track_num $track_num2 
	set file_num $n
	set types {{{Wav files} {*.wav}} {{mp3 files} {*.mp3}} {{raw files} {*.raw}} {{efw files} {*.efw}} {{all} {*}}}
	file_browser"
	entry $w4.entry2_$n -bg White -font $mt_font -width 2 -textvariable mfe(start1$pointer)
	entry $w4.entry2b_$n -bg White -font $mt_font -width 2 -textvariable mfe(start2$pointer)
	entry $w4.entry3_$n -bg White -font $mt_font -width 2 -textvariable mfe(duration1$pointer)
	entry $w4.entry3b_$n -bg White -font $mt_font -width 2 -textvariable mfe(duration2$pointer)
	checkbutton $w4.play$n -width 1 -bg $bgcolor3 -variable mfe(status$pointer) -onvalue "Play" -offvalue "Mute"
	checkbutton $w4.rec$n -width 1 -bg $bgcolor3 -variable mfe(status$pointer)  -onvalue "Rec"
	button $w4.wave_edit$n -font $mt_font -bg LightBlue3 -activebackground LightSeaGreen -text "Wave Edit" -command "
	set track_num $track_num2
	set file_num $n
	wave_edit"
	
	grid $w4.entry1_$n $w4.open$n $w4.entry2_$n $w4.entry2b_$n $w4.entry3_$n $w4.entry3b_$n $w4.play$n $w4.rec$n $w4.wave_edit$n -sticky ewns
}

proc ladspa {} {

global eca_effects effect_param effect_param_name effect_param_to effect_param_from effect_param_resolution effect_param_value effect_index effect_name effect_copy effect_maker ladspa_path env



set env(LADSPA_PATH) $ladspa_path  

set cmd "exec listplugins"
catch {eval $cmd} exec_out1

if {[string match *egmentation* $exec_out1] == 1} {
return}

set exec_out2 [split $exec_out1 \n]
set file_number 0
set parameters 0

for {set n 0} {$n <= [llength $exec_out2]} {incr n} {
    set current_line [lindex $exec_out2 $n]
    if {[string match *.so* $current_line] == 1} {
	regsub : $current_line {} current_line
	set files($file_number) $current_line
	incr file_number

    }
}

set exec_out2 " "

for {set n 0} {$n < $file_number} {incr n} {

    set cmd "exec analyseplugin $files($n)"
    catch {eval $cmd} exec_out1
    set exec_out2 "$exec_out2$exec_out1"

}

set exec_out3 [split $exec_out2 \n]
set index $eca_effects

for {set n 0} {$n <= [llength $exec_out3]} {incr n} {
    set current_line [lindex $exec_out3 $n]
    if {[string match {Plugin Label:*} $current_line] == 1} {    
	set parameters 0
	regsub {Plugin Label: "} $current_line {} plugin_label
	regsub {"} $plugin_label {} plugin_label
	set effect_param(ladspa_$plugin_label) 0
	set effect_index($index) "ladspa_$plugin_label" 
	incr index
	set past_line [lindex $exec_out3 [expr $n-1]]
	regsub {Plugin Name: "} $past_line {} plugin_name
	regsub {"} $plugin_name {} effect_name(ladspa_$plugin_label)
 	set n [expr $n+2]
	set current_line [lindex $exec_out3 $n]	
	regsub {Maker: "} $current_line {} plugin_maker
	regsub {"} $plugin_maker {}  effect_maker(ladspa_$plugin_label)
	incr n
	set current_line [lindex $exec_out3 $n]	
	regsub {Copyright: "} $current_line {} plugin_copy
	regsub {"} $plugin_copy {}  effect_copy(ladspa_$plugin_label)
	set n [expr $n+6]
	set current_line [lindex $exec_out3 $n]	
    }	
    
    if {[string match {Ports:*} $current_line] == 1 || $parameters == 1} {
	set parameters 1
	if {[string match {*control,*} $current_line] ==1 } {
	    if {[string match *ERROR:* $current_line ] == 1 || [string match *toggled* $current_line ] == 1} {
		incr effect_param(ladspa_$plugin_label)
		set effect_param_to(ladspa_$plugin_label$effect_param(ladspa_$plugin_label)) 0
		set effect_param_from(ladspa_$plugin_label$effect_param(ladspa_$plugin_label)) 0
		set effect_param_resolution(ladspa_$plugin_label$effect_param(ladspa_$plugin_label)) 1
		set effect_param_value(ladspa_$plugin_label$effect_param(ladspa_$plugin_label)) 0
	    }
	    regsub -all {\*srate} $current_line {} current_line
	    if {[regexp -all {([-+.0-9]+)( to)} $current_line param_from] == 1} {
	    	incr effect_param(ladspa_$plugin_label)
		regsub -all { to} $param_from {} effect_param_from(ladspa_$plugin_label$effect_param(ladspa_$plugin_label))
		set effect_param_value(ladspa_$plugin_label$effect_param(ladspa_$plugin_label)) $effect_param_from(ladspa_$plugin_label$effect_param(ladspa_$plugin_label))
	    } 
	    if {[regexp -all {(\")([(= ),&+-?/%A-Za-z0-9]+)(\")} $current_line param_name] == 1} {
		regsub -all {\"} $param_name {} effect_param_name(ladspa_$plugin_label$effect_param(ladspa_$plugin_label))
	    }

	    if {[regexp -all {(to )([-+.0-9]+)} $current_line param_to] == 1} {
		regsub -all {to } $param_to {} effect_param_to(ladspa_$plugin_label$effect_param(ladspa_$plugin_label))
		if {[string match {*integer*} $current_line]} {set effect_param_resolution(ladspa_$plugin_label$effect_param(ladspa_$plugin_label)) 1} else {
		    set effect_param_resolution(ladspa_$plugin_label$effect_param(ladspa_$plugin_label)) 0
	    }
	    if {[string match {*logarithmic*} $current_line] == 1} {
		    set effect_param_resolution(ladspa_$plugin_label$effect_param(ladspa_$plugin_label)) 100	    
	    }
	    if {[string match *...* $effect_param_to(ladspa_$plugin_label$effect_param(ladspa_$plugin_label))] == 1} {	
		    set effect_param_to(ladspa_$plugin_label$effect_param(ladspa_$plugin_label)) 10000
		    set effect_param_resolution(ladspa_$plugin_label$effect_param(ladspa_$plugin_label)) 100	    	
	    }
	    if {[string match *...* $effect_param_from(ladspa_$plugin_label$effect_param(ladspa_$plugin_label))] == 1} {	
		    set effect_param_from(ladspa_$plugin_label$effect_param(ladspa_$plugin_label)) 10000	
		    set effect_param_resolution(ladspa_$plugin_label$effect_param(ladspa_$plugin_label)) 100	    	
	    }
	
	} 
	}
    }
        
}

set eca_effects [expr $index - 1]

}

proc add_track {} {
    global mfe number_of_tracks number_of_files mt_font n eca_effects effect_index effect_name mfe_temp w track_num bgcolor3
    set bgcolor3 AntiqueWhite2
    set n $number_of_tracks
    set mfe(track_status$n) "Play"
    set mfe(rec_prop_bits$n) "s16_le"
    set mfe(rec_prop_channels$n) "1"
    set mfe(rec_prop_srate$n) "44100"
    set mfe(rec_prop_interl$n) "i"
    set mfe(volume$n) 100
    set mfe(pan$n) 50
    set mfe(device$n) "/dev/dsp"
    set mfe(files$n) 0
    set number $n
    .mfe.tracks.canvas config -scrollregion "0 0 0 [expr $number_of_tracks *29]"
	if {$n < 10} {set number "0$n"}

	label $w.number$n -bg AntiqueWhite -font $mt_font -text $number
	entry $w.name$n -bg White -font $mt_font -width 21 -textvariable mfe(track_name$n)
	button $w.wave_info$n -bg LightPink2 -activebackground LightSeaGreen -font $mt_font -text "Wave Info" -relief raised -command "
	set track_num $n 
	wave_files"

	menubutton $w.dev_text$n -bg LightSkyBlue -activebackground LightSeaGreen -font $mt_font -text "Dev." -relief raised -menu $w.dev_text$n.type
	menu $w.dev_text$n.type -tearoff 0
	    $w.dev_text$n.type add radiobutton -label /dev/dsp -variable mfe(device$n) -value "/dev/dsp"
	    $w.dev_text$n.type add radiobutton -label /dev/dsp1 -variable mfe(device$n) -value "/dev/dsp1"
	    $w.dev_text$n.type add radiobutton -label /dev/dsp2 -variable mfe(device$n) -value "/dev/dsp2"
	    $w.dev_text$n.type add radiobutton -label /dev/dsp3 -variable mfe(device$n) -value "/dev/dsp3"
    	    $w.dev_text$n.type add radiobutton -label /dev/dsp4 -variable mfe(device$n) -value "/dev/dsp4"
	    $w.dev_text$n.type add radiobutton -label /dev/dsp5 -variable mfe(device$n) -value "/dev/dsp5"
	    $w.dev_text$n.type add radiobutton -label /dev/dsp6 -variable mfe(device$n) -value "/dev/dsp6"
	    $w.dev_text$n.type add radiobutton -label /dev/dsp7 -variable mfe(device$n) -value "/dev/dsp7"
	entry $w.dev_entry$n -bg White -font $mt_font -width 8 -textvariable mfe(device$n)

	checkbutton $w.play$n -width 1 -bg $bgcolor3 -variable mfe(track_status$n) -onvalue "Play" -offvalue "Mute"
	checkbutton $w.rec$n -width 1 -bg $bgcolor3 -variable mfe(track_status$n)  -onvalue "Rec" -command "
	set track_num $n
	set mixdown 0
	rec_properties" 

	for {set en 1} {$en <= 4} {incr en} {
	    set mfe(effect$en$n) "None"
	    set mfe_temp(effect$en$n) "None"

	    menubutton $w.effect$en$n -width 0 -bg LightPink2 -activebackground LightSeaGreen -font $mt_font -text "$en" -relief raised -menu $w.effect$en$n.type
	    menu $w.effect$en$n.type -tearoff 0	    
		$w.effect$en$n.type add command -label "None" -command "
		    set effect_num $en
		    set track_num $n
		    set mfe(effect$en$n) None
		    set mfe_temp(effect$en$n) None
		    effect"
		$w.effect$en$n.type add command -label "Edit Current Effect" -command "
		    set effect_num $en
		    set track_num $n
		    effect"
		$w.effect$en$n.type add command -label "Add a New Effect" -command "
		    set effect_num $en
		    set track_num $n
		    effect_list"
    		    
	}		
    
	menubutton $w.eca_tools$n -font $mt_font -bg LightBlue3 -activebackground LightSeaGreen -text "Eca tools" -relief raised -menu $w.eca_tools$n.type
	menu $w.eca_tools$n.type -tearoff 0
	$w.eca_tools$n.type add command -label "Normalize" -command "
	set track_num $n
	ecanormalize"
	$w.eca_tools$n.type add command -label "DC Offset Fix" -command "
	set track_num $n
	ecafixdc"

	scale $w.pan$n -bg $bgcolor3 -activebackground red -font $mt_font -from 0 -to 100 -length 100 -width 3 -orient horizontal -showvalue true -variable mfe(pan$n)

	scale $w.slide$n -bg $bgcolor3 -activebackground red -font $mt_font -resolution 1 -from 0 -to 300 -length 165 -width 3 -orient horizontal -showvalue true -variable mfe(volume$n) 
	grid $w.number$n $w.name$n $w.wave_info$n $w.dev_text$n $w.dev_entry$n $w.play$n $w.rec$n $w.effect1$n $w.effect2$n $w.effect3$n $w.effect4$n $w.eca_tools$n $w.pan$n $w.slide$n -sticky ewns

}

proc file_browser {} {
    global mfe n types track_num track_num2 file_num
    if {$mfe(directory)==""} {set mfe(directory) "."}
    if {$track_num == 0} {
	set mfe(openfile0) [tk_getOpenFile -initialdir $mfe(directory) -filetypes $types]
	open_file
	} else {
	set track "track"
	set pointer "file$file_num$track$track_num2"
	set mfe($pointer) [tk_getOpenFile -initialdir $mfe(directory) -filetypes $types]
	if {$mfe($pointer) != ""} {
	    set mfe(status$pointer) "Play"
	}
    }
}

proc file_browser2 {} {
    global mfe n types track_num save_as
    set save_as 1
    if {$mfe(directory)==""} {set mfe(directory) "."}
    set mfe(openfile$track_num) [tk_getSaveFile -initialdir $mfe(directory) -filetypes $types]
}

proc play {} {
    global mfe number_of_tracks msg stop_command sp_minutes sp_seconds effect_param recording playhandle mixdown export_ecs eca_string
    if {$mfe(directory)==""} {set mfe(directory) "."}
    set start_time [expr $sp_minutes*60+$sp_seconds]
    set eca_string ""
    set eca_string2 ""
    set track_count 0
    set number_of_devices 0
    set device(0) " "
    set device(1) " "
    set added_device 0
    set tracks_to_play 0
    set track "track"
    for {set n 1} {$n <= $number_of_tracks} {incr n} {
    for {set nf 1} {$nf <= $mfe(files$n)} {incr nf} {
	set pointer "file$nf$track$n"
	if {[string length $mfe(file$nf$track$n)] > 3} { 
	    if {$mfe(track_status$n)=="Play" && $mfe(status$pointer)=="Play"} {
		set tmp_ewf [open "$mfe(directory)/tmp_file$nf$track$n.ewf" w]
		puts $tmp_ewf "source=$mfe(file$nf$track$n)"
		set offset [expr $mfe(start2file$nf$track$n)+$mfe(start1file$nf$track$n)*60]
		puts $tmp_ewf "offset=$offset"
		puts $tmp_ewf "start-position=0"
		if {$mfe(duration2file$nf$track$n)!= "" && $mfe(duration1file$nf$track$n)!= ""} {
		    set duration [expr $mfe(duration2file$nf$track$n)+$mfe(duration1file$nf$track$n)*60]
		} else {set duration " "}
		puts $tmp_ewf "length=$duration"
		puts $tmp_ewf "looping=false"
		close $tmp_ewf
		set eca_string "$eca_string -a:file$nf$track$n -i $mfe(directory)/tmp_file$nf$track$n.ewf -ea:$mfe(volume$n) -epp:$mfe(pan$n) "
		set tracks_to_play 1
		for {set nd 0} {$nd <= $number_of_devices} {incr nd} {
		    if {$device($nd)==$mfe(device$n)} {
			set device_chains($nd) "$device_chains($nd),file$nf$track$n"
			set added_device 1
		    }
		}
		if {$added_device==0} {
		    incr number_of_devices
		    set device_chains($number_of_devices) "file$nf$track$n"
		    set device($nd) $mfe(device$n)
		    
		} else {
		    set added_device 0
		}
		incr track_count
	    
	    for {set en 1} {$en <= 4} {incr en} { 
		if {$mfe(effect$en$n) != "None" } {
		    if {[string match ladspa* $mfe(effect$en$n)]==1} {
			regsub ladspa_ $mfe(effect$en$n) {} current_effect
			set eca_string "$eca_string -el:$current_effect,"
		    } else {
			set eca_string "$eca_string -$mfe(effect$en$n):"
		    }	
		    for {set par 1} {$par <= $effect_param($mfe(effect$en$n)) } {incr par} { 
			if {$par>1} {set eca_string "$eca_string,"}
			set eca_string "$eca_string$mfe(effect_parameter$par$en$n)"
		    }
		}    
	    }
	
	    }

	    if {$mfe(track_status$n)=="Rec" && $mixdown != 1 && $mfe(status$pointer)=="Rec"} {	
		if {$recording == 1} {	

		set tmp_ewf [open "$mfe(directory)/tmp_file$nf$track$n.ewf" w]
		puts $tmp_ewf "source=$mfe(file$nf$track$n)"
		set offset [expr $mfe(start2file$nf$track$n)+$mfe(start1file$nf$track$n)*60]
		puts $tmp_ewf "offset=$offset"
		puts $tmp_ewf "start-position=0"
		if {$mfe(duration2file$nf$track$n)!= "" && $mfe(duration1file$nf$track$n)!= ""} {
		    set duration [expr $mfe(duration2file$nf$track$n)+$mfe(duration1file$nf$track$n)*60]
		} else {set duration " "}
		puts $tmp_ewf "length=$duration"
		puts $tmp_ewf "looping=false"
		close $tmp_ewf

		    set eca_string "$eca_string -a:file$nf$track$n -f:$mfe(rec_prop_bits$n),$mfe(rec_prop_channels$n)ch,$mfe(rec_prop_srate$n),$mfe(rec_prop_interl$n) -i $mfe(device$n) -o $mfe(directory)/tmp_file$nf$track$n.ewf"
		    incr track_count
		    set tracks_to_play 1
		} else {
		    incr track_count
		}
		 
	    }	
	}
    set eca_string "$eca_string \n"
    }    
    }

if {$track_count > 0 && $tracks_to_play == 1} {
    for {set n 1} {$n <= $number_of_devices} {incr n} {
	set eca_string2 "$eca_string2-a:$device_chains($n) -o $device($n)\n "   
    }

    if {$mixdown == 1} {
	set eca_string2 "-a:all -f:$mfe(rec_prop_bitsMD),$mfe(rec_prop_channelsMD)ch,$mfe(rec_prop_srateMD),$mfe(rec_prop_interlMD) -o $mfe(openfileMD)"
	set mixdown 0
    }
    
    set eca_string "$eca_string $eca_string2"
    puts $eca_string
    if {$export_ecs == 1} {return}
    set playhandle [open "|ecasound -c $eca_string" w]
    fconfigure $playhandle -buffering none -blocking 0
    puts $playhandle "setpos $start_time\n"
    puts $playhandle "t\n"
} else { 
set stop_command 1
messages [format "No tracks to be played or recorded"]}
}

proc stop {} {
    global stop_command playhandle stop_position
    puts $playhandle "s\n"
#    catch {eval puts $playhandle "dump-position"} stop_position 
    puts $playhandle "q\n"
    set stop_command 1
}

proc effect {} {
    global mfe mfe_temp mfe_temp2 effect_num effect2 track_num track effect_name effect_param_name effect_param effect_param_value effect_param_from effect_param_to effect_param_resolution effect_maker effect_copy mt_font logarithmic position stop_command bgcolor
    
    if {[winfo exists .effect$effect_num$track_num] != 0} {destroy .effect$effect_num$track_num}
    set effect_label $mfe_temp(effect$effect_num$track_num)
    if { $mfe_temp(effect$effect_num$track_num) == "None"} {
	set mfe(effect$effect_num$track_num) $mfe_temp(effect$effect_num$track_num)
	return
    }
    set effect_label $mfe_temp(effect$effect_num$track_num)
    toplevel .effect$effect_num$track_num
    message .effect$effect_num$track_num.out -width 300 -bg $bgcolor -text "Track:$track_num Effect:$effect_num\n$effect_name($mfe_temp(effect$effect_num$track_num))"
    pack .effect$effect_num$track_num.out -expand yes -fill x    
    message .effect$effect_num$track_num.out2 -width 300 -text " "
    pack .effect$effect_num$track_num.out2 -expand yes -fill x    
    
    if { $mfe(effect$effect_num$track_num) != $mfe_temp(effect$effect_num$track_num) } {
	set mfe(effect$effect_num$track_num) $mfe_temp(effect$effect_num$track_num)
	for {set n 1} {$n <= $effect_param($effect_label)} {incr n} {	    
	    set mfe(effect_parameter$n$effect_num$track_num) $effect_param_value($effect_label$n)
	    set mfe_temp2(effect_parameter$n$effect_num$track_num) $effect_param_value($effect_label$n)
	}
    }
    set mfe(effect_parameters$effect_num$track_num) $effect_param($effect_label)
    for {set n 1} {$n <= $effect_param($effect_label)} {incr n} {
	set res [expr ($effect_param_to($effect_label$n)-$effect_param_from($effect_label$n))/100]
	set res [expr abs($res)]
	set logarithmic 0
	if {$effect_param_resolution($effect_label$n) != 0 } {set res $effect_param_resolution($effect_label$n)}
	if {$effect_param_resolution($effect_label$n) == 100 } {
	    set res [expr ($effect_param_to($effect_label$n)-$effect_param_from($effect_label$n))/10000]
	    set res [expr abs($res)]
	    set logarithmic 1
	}
	set position "effect_parameter$n$effect_num$track_num"
	frame .effect$effect_num$track_num.$n
	scale .effect$effect_num$track_num.$n.param$n -font $mt_font -from $effect_param_from($effect_label$n) -to $effect_param_to($effect_label$n) -resolution $res -length 300 -width 3 -orient horizontal -showvalue false -variable mfe_temp2($position) -command "
	set position effect_parameter$n$effect_num$track_num
	log" 
	pack .effect$effect_num$track_num.$n.param$n 
	label .effect$effect_num$track_num.$n.param_name$n -text "$effect_param_name($effect_label$n): "
	entry .effect$effect_num$track_num.$n.param_value$n -width 5 -justify left -relief flat -textvariable mfe($position)
	pack .effect$effect_num$track_num.$n.param_name$n -side left -fill x
	pack .effect$effect_num$track_num.$n.param_value$n -side left 
	pack .effect$effect_num$track_num.$n
    }

    frame .effect$effect_num$track_num.buttons -bd 3 -bg $bgcolor
    button .effect$effect_num$track_num.buttons.close -bg AntiqueWhite -activebackground LightPink -text Close -command "
	set effect2 $effect_num
	set track $track_num
	close_effect
    "

    button .effect$effect_num$track_num.buttons.preview -bg AntiqueWhite -activebackground LightPink -text "Preview" -height 0 -command { 
    if {$stop_command == 1} { 
	set stop_command 0
	set preview 1
	set effect2 "$effect_num"
	set track "$track_num"
	preview } else {
	stop
	set preview 1
	set effect2 "$effect_num"
	set track "$track_num"
	set stop_command 0
	preview
	}
    } 
    button .effect$effect_num$track_num.buttons.full_preview -bg AntiqueWhite -activebackground LightPink -text "Full Prev." -height 0 -command { 
    if {$stop_command == 1} { 
	set stop_command 0
	set preview 2
	set track "$track_num"
	preview } else {
	stop
	set preview 2
	set effect2 "$effect_num"
	set track "$track_num"
	set stop_command 0
	preview
	}
    } 

    button .effect$effect_num$track_num.buttons.stop -bg AntiqueWhite -activebackground LightPink -text "Stop" -height 0 -command { 
    if {$stop_command == 0} { 
	set stop_command 1
	stop}
    }
    button .effect$effect_num$track_num.buttons.info -bg AntiqueWhite -activebackground LightPink -text "Info" -command {
    set plugin_info "Plug-in Name: $effect_name($mfe_temp(effect$effect_num$track_num))\nMaker: $effect_maker($mfe_temp(effect$effect_num$track_num))\nCopyright: $effect_copy($mfe_temp(effect$effect_num$track_num))"
    messages [format $plugin_info]    
    }
     
    pack .effect$effect_num$track_num.buttons.preview -side left
    pack .effect$effect_num$track_num.buttons.full_preview -side left
    pack .effect$effect_num$track_num.buttons.stop -side left
    pack .effect$effect_num$track_num.buttons.close -side left
    pack .effect$effect_num$track_num.buttons.info -side left
    pack .effect$effect_num$track_num.buttons -in .effect$effect_num$track_num -side top -expand 1 -fill both
    
}

proc messages {msg} {
    if {[winfo exists .msg] != 0} {destroy .msg}
    toplevel .msg
    message .msg.out -width 300 -text $msg
    button .msg.button -text Ok -command {destroy .msg}
    pack .msg.out -expand y -fill x
    pack .msg.button
}

proc ecanormalize {} {
    global mfe track_num
    if {[winfo exists .normalize] != 0} {destroy .normalize}
    toplevel .normalize
    message .normalize.out -width 300 -text "Are you sure you want to Normalize\nfiles on Track $track_num" 
    button .normalize.button1 -text Cancel -command {destroy .normalize}
    button .normalize.button2 -text Ok -command { 
        set track "track"
        for {set nf 1} {$nf <= $mfe(files$track_num)} {incr nf} {
	    set pointer "file$nf$track$track_num"
	    if {[string length $mfe($pointer)] > 3} { 
		set cmd "exec ecanormalize $mfe($pointer) &" 
		catch {eval $cmd} exec_out
	    }
	}
	destroy .normalize
    }
    pack .normalize.out 
    pack .normalize.button1 -padx 30 -side left 
    pack .normalize.button2 -padx 30
}

proc ecafixdc {} {
    global mfe track_num
    if {[winfo exists .fixdc] != 0} {destroy .fixdc}
    toplevel .fixdc
    message .fixdc.out -width 300 -text "Are you sure you want to fix DC Offset\nin files on Track $track_num" 
    button .fixdc.button1 -text Cancel -command {destroy .fixdc}
    button .fixdc.button2 -text Ok -command { 
        set track "track"
        for {set nf 1} {$nf <= $mfe(files$track_num)} {incr nf} {
	    set pointer "file$nf$track$track_num"
	    if {[string length $mfe($pointer)] > 3} { 
    		set cmd "exec ecafixdc $mfe($pointer) &" 
		catch {eval $cmd} exec_out
	    }
	}
    destroy .fixdc
    }
    pack .fixdc.out 
    pack .fixdc.button1 -padx 35 -side left 
    pack .fixdc.button2 -padx 35
}

proc wave_edit {} {
    global mfe track_num wave_editor file_num
    set track "track"
    set pointer "file$file_num$track$track_num"
    set cmd "exec $wave_editor $mfe($pointer) &" 
    catch {eval $cmd} exec_out
}

proc save_file {} {
    global mfe number_of_tracks sp_minutes sp_seconds save_as track_num types
    if {$mfe(openfile0) == ""} {
	if {$save_as == 1} {return} else {
	    set types {{{mfe files} {*.mfe}} {{all} {*}}}
	    set track_num 0
	    file_browser2
	    if {$mfe(openfile0) == ""} {return}
	}
    }
    set file_to_save [open "$mfe(openfile0)" w]
    puts $file_to_save "This file was created by tkeca.tcl"
    puts $file_to_save "$number_of_tracks"
    puts $file_to_save "$sp_minutes"
    puts $file_to_save "$sp_seconds"

    for {set n 1} {$n <= $number_of_tracks} {incr n} {
	puts $file_to_save "$mfe(track_name$n)"
	puts $file_to_save "$mfe(files$n)"
	set track "track"
	for {set nf 1} {$nf <= $mfe(files$n)} {incr nf} {
	    set pointer "file$nf$track$n"
	    puts $file_to_save  "$mfe($pointer)"
	    puts $file_to_save  "$mfe(start1$pointer)"
	    puts $file_to_save  "$mfe(start2$pointer)"
	    puts $file_to_save  "$mfe(duration1$pointer)"
	    puts $file_to_save  "$mfe(duration2$pointer)"
	    puts $file_to_save  "$mfe(status$pointer)"
	}
	puts $file_to_save "$mfe(device$n)"
	puts $file_to_save "$mfe(track_status$n)"
	for {set en 1} {$en <= 4} {incr en} {
	    puts $file_to_save "$mfe(effect$en$n)"
	    if {$mfe(effect$en$n)!="None"} {
		puts $file_to_save "$mfe(effect_parameters$en$n)"
		for {set p 1} {$p <= $mfe(effect_parameters$en$n)} {incr p} {
		    puts $file_to_save "$mfe(effect_parameter$p$en$n)"		
		}
	    }
	}
	puts $file_to_save "$mfe(volume$n)"
	puts $file_to_save "$mfe(pan$n)"
    }
    puts $file_to_save "\n"
    close $file_to_save	
    messages [format "File $mfe(openfile0) saved"]
}

proc open_file {} {
    global mfe mfe_temp number_of_tracks sp_minutes sp_seconds w
    if {$mfe(openfile0) == ""} {
	return
    }
    set line_number 0
    set file_to_open [open "$mfe(openfile0)" r]
    while {[gets $file_to_open input_line] != -1 } {
	set temp_file($line_number) $input_line
	incr line_number
    }
    set line_number 0
    if {$temp_file($line_number)!="This file was created by tkeca.tcl"} {
	messages [format "File $mfe(openfile0) was not created by tkeca.tcl"]
	return	
    }
    incr line_number
    set number_of_tracks3 $number_of_tracks
    set number_of_tracks $temp_file($line_number)
    set number_of_tracks2 $number_of_tracks
    for {set number_of_tracks 1} {$number_of_tracks <= $number_of_tracks3} {incr number_of_tracks} {
	destroy $w.number$number_of_tracks 
	destroy $w.name$number_of_tracks 
	destroy $w.wave_info$number_of_tracks 
	destroy $w.dev_text$number_of_tracks 
	destroy $w.dev_entry$number_of_tracks 
	destroy $w.play$number_of_tracks 
	destroy $w.rec$number_of_tracks 
	destroy $w.effect1$number_of_tracks 
	destroy $w.effect2$number_of_tracks 
	destroy $w.effect3$number_of_tracks 
	destroy $w.effect4$number_of_tracks 
	destroy $w.eca_tools$number_of_tracks 
	destroy $w.pan$number_of_tracks 
	destroy $w.slide$number_of_tracks
    }
    for {set number_of_tracks 1} {$number_of_tracks <= $number_of_tracks2} {incr number_of_tracks} {
	add_track
    }
    set number_of_tracks $number_of_tracks2
    incr line_number
    set sp_minutes $temp_file($line_number)
    incr line_number
    set sp_seconds $temp_file($line_number)
    incr line_number
    for {set n 1} {$n <= $number_of_tracks} {incr n} {
	set mfe(track_name$n) $temp_file($line_number)
	incr line_number
	set mfe(files$n) $temp_file($line_number)
	incr line_number
	set track "track"
	for {set nf 1} {$nf <= $mfe(files$n)} {incr nf} {
	    set pointer "file$nf$track$n"
	    set mfe($pointer) $temp_file($line_number)
	    incr line_number
	    set mfe(start1$pointer) $temp_file($line_number)
	    incr line_number
	    set mfe(start2$pointer) $temp_file($line_number)
	    incr line_number
	    set mfe(duration1$pointer) $temp_file($line_number)
	    incr line_number
	    set mfe(duration2$pointer) $temp_file($line_number)
	    incr line_number
	    set mfe(status$pointer) $temp_file($line_number)
	    incr line_number

	}
	set mfe(device$n) $temp_file($line_number)
	incr line_number
	set mfe(track_status$n) $temp_file($line_number)
	incr line_number

	for {set en 1} {$en <= 4} {incr en} {
	    set mfe(effect$en$n) $temp_file($line_number)
	    set mfe_temp(effect$en$n) $temp_file($line_number)
	    incr line_number
	    if {$mfe(effect$en$n)!="None"} {
		set mfe(effect_parameters$en$n) $temp_file($line_number)
		incr line_number
		for {set p 1} {$p <= $mfe(effect_parameters$en$n)} {incr p} {
		    set mfe(effect_parameter$p$en$n) $temp_file($line_number)  		
		    incr line_number
		}
	    }
	}
	set mfe(volume$n) $temp_file($line_number)
	incr line_number
	set mfe(pan$n) $temp_file($line_number)
	incr line_number
    }
}

proc proc_about {} {
messages [format "Tkeca is a Tcl/Tk frontend for Kai Vehmanen's Ecasound
Copyright (C) 2002-2003  Luis Pablo Gasparotto
This program is free software; you can redistribute it and/or modify \
it under the terms of the GNU General Public License as published by \
the Free Software Foundation; either version 2 of the License, or \
(at your option) any later version.

This program is distributed in the hope that it will be useful, \
but WITHOUT ANY WARRANTY; without even the implied warranty of \
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the \
GNU General Public License for more details.

You should have received a copy of the GNU General Public License \
along with this program; if not, write to the Free Software \
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

To contact me: luispa8@yahoo.com.ar"]}

proc proc_exit {} {
    global mfe mfe_temp number_of_tracks sp_minutes sp_seconds saved exit_yes save_as
    set saved 1
    set line_number 0
    if {$number_of_tracks == 0} {
	set saved 2
    }
    if {$mfe(openfile0) == ""} {
    set saved [expr $saved - 1]} else {
    set file_to_open [open "$mfe(openfile0)" r]
    while {[gets $file_to_open input_line] != -1 } {
	set temp_file($line_number) $input_line
	incr line_number
    }
    set line_number 1
    if {$number_of_tracks != $temp_file($line_number)} {set saved 0}
    incr line_number
    if {$sp_minutes != $temp_file($line_number)} {set saved 0}
    incr line_number
    if {$sp_seconds != $temp_file($line_number)} {set saved 0}
    incr line_number
    for {set n 1} {$n <= $number_of_tracks && $saved >0} {incr n} {
	if {$mfe(track_name$n) != $temp_file($line_number)} {set saved 0}
	incr line_number
	if {$mfe(files$n)!= $temp_file($line_number)} {
	    set saved 0 } else {
	    incr line_number
	    set track "track"
	    for {set nf 1} {$nf <= $mfe(files$n)} {incr nf} {
		set pointer "file$nf$track$n"
		if {$mfe($pointer) != $temp_file($line_number)} {set saved 0}
		incr line_number
		if {$mfe(start1$pointer) != $temp_file($line_number)} {set saved 0}
		incr line_number
		if {$mfe(start2$pointer) != $temp_file($line_number)} {set saved 0}
		incr line_number
		if {$mfe(duration1$pointer) != $temp_file($line_number)} {set saved 0}
		incr line_number
		if {$mfe(duration2$pointer) != $temp_file($line_number)} {set saved 0}
		incr line_number
		if {$mfe(status$pointer) != $temp_file($line_number)} {set saved 0}
		incr line_number
	    }
	}
	if {$mfe(device$n) != $temp_file($line_number)} {set saved 0} 
	incr line_number
	if {$mfe(track_status$n) != $temp_file($line_number)} {set saved 0} 
	incr line_number

	for {set en 1} {$en <= 4 && $saved > 0} {incr en} {
	    if {$mfe(effect$en$n) != $temp_file($line_number)} {set saved 0} 
	    if {$mfe_temp(effect$en$n) != $temp_file($line_number)} {set saved 0} 
	    incr line_number
	    if {$mfe(effect$en$n)!="None"} {
		set effect_parameters $temp_file($line_number)
		incr line_number
		for {set p 1} {$p <= $effect_parameters && $saved >0} {incr p} {
		    if {$mfe(effect_parameter$p$en$n) != $temp_file($line_number)} {set saved 0}   		
		    incr line_number
		}
	    }
	}
	if {$mfe(volume$n) != $temp_file($line_number)} {set saved 0} 
	incr line_number
	if {$mfe(pan$n) != $temp_file($line_number)} {set saved 0} 
	incr line_number
    }
    }
    if {$saved == 0} {
	toplevel .save_alert
	message .save_alert.out -width 300 -text "You will lose the latest changes! \nWhat do you want to do?" 
	button .save_alert.button1 -text Cancel -command {
	destroy .save_alert
	}
	button .save_alert.button2 -text "Lose changes" -command { 
	    destroy .save_alert
	    if {$exit_yes==1} {exit}
	}
	button .save_alert.button3 -text "Save changes" -command { 
	    destroy .save_alert
	    set save_as 0
	    save_file
	    if {$exit_yes==1} {exit}
	}
	pack .save_alert.out 
	pack .save_alert.button1 -padx 10 -side left 
	pack .save_alert.button2 -padx 10 -side left 
	pack .save_alert.button3 -padx 10
    } else {
	if {$exit_yes==1} {exit}
    }
}
proc mixdown {} {
    global track_num mixdown mfe types number_of_tracks
    set types {{{Wav files} {*.wav}} {{mp3 files} {*.mp3}} {{raw files} {*.raw}} {{all} {*}}}
    set mfe(rec_prop_bitsMD) "s16_le"
    set mfe(rec_prop_channelsMD) "2"
    set mfe(rec_prop_srateMD) "44100"
    set mfe(rec_prop_interlMD) "i"
    set track_num "MD"
    set mfe(track_statusMD) "Rec"
    if {$number_of_tracks==0} {
	messages [format "There's no tracks to make Mixdown!"]
	return
    }
    set mixdown 1
    rec_properties
}

proc export_ecs {} {
    global export_ecs eca_string mfe recording
    set export_ecs 1
    set recording 1
    play
    set export_ecs 0
    set types {{{Ecasound Chain Setup} {*.ecs}}}
    if {$mfe(directory)==""} {set mfe(directory) "."}
    set ecs_file [tk_getSaveFile -initialdir $mfe(directory) -filetypes $types]
    if {$ecs_file==""} {return}
    set ecs_exported_file [open "$ecs_file" w]
    puts $ecs_exported_file $eca_string
    close $ecs_exported_file 
}

proc pause {} {
    global pause playhandle
    if {$pause == "Pause"} {
	puts $playhandle "s\n"
	set pause "Continue"    
    } else {
    	puts $playhandle "t\n"    
	set pause "Pause"
    }

}
proc log {value} {
    global mfe logarithmic position mfe_temp2
    if {$logarithmic == 1} {
	set mfe($position) [expr $mfe_temp2($position)/100]
	set mfe($position) [expr $mfe($position)*$mfe($position)]
    } else {set mfe($position) $mfe_temp2($position)} 
}

proc effect_list {} {
    global mfe mfe_temp track_num effect_num eca_effects effect_index effect_name bgcolor
    if {[winfo exists .effect$effect_num$track_num] != 0} {destroy .effect$effect_num$track_num}
    toplevel .effect$effect_num$track_num -bg $bgcolor
    frame .effect$effect_num$track_num.list
    listbox .effect$effect_num$track_num.list.list -width 40 -selectmode single -yscrollcommand {.effect$effect_num$track_num.list.ysbar set} -exportselection 0
    scrollbar .effect$effect_num$track_num.list.ysbar -width 8 -command {.effect$effect_num$track_num.list.list yview}
    pack .effect$effect_num$track_num.list.list -side left -fill y
    pack .effect$effect_num$track_num.list.ysbar -side left -fill y
    pack .effect$effect_num$track_num.list -in .effect$effect_num$track_num -side top
    .effect$effect_num$track_num.list.list insert end "None"
    for {set en 1} {$en <= $eca_effects } {incr en} {
	.effect$effect_num$track_num.list.list insert end $effect_name($effect_index($en))
    }
    frame .effect$effect_num$track_num.buttons -bg $bgcolor
    button .effect$effect_num$track_num.buttons.button1 -bg AntiqueWhite -activebackground LightPink -text Ok -command {
    set selected [.effect$effect_num$track_num.list.list curselection]
    if {$selected < 1} {set selected 0}
    set mfe_temp(effect$effect_num$track_num) $effect_index($selected)
    effect}
    button .effect$effect_num$track_num.buttons.button2 -bg AntiqueWhite -activebackground LightPink -text Cancel -command {
    destroy .effect$effect_num$track_num
    return}
    pack .effect$effect_num$track_num.buttons.button1 -padx 50 -side left
    pack .effect$effect_num$track_num.buttons.button2 -padx 50 -side left
    pack .effect$effect_num$track_num.buttons -in .effect$effect_num$track_num -side bottom -fill x
}

proc preview {} {
    global mfe msg stop_command sp_minutes sp_seconds effect_param playhandle mixdown eca_string track effect effect2 preview
    set start_time [expr $sp_minutes*60+$sp_seconds]
    set eca_string ""
    set track2 "track"
    set n $track
    set tracks_to_play 0
    for {set nf 1} {$nf <= $mfe(files$n)} {incr nf} {
	set pointer "file$nf$track2$n"
	if {[string length $mfe($pointer)] > 3} { 
	    if {$mfe(status$pointer)=="Play"} {
		set tmp_ewf [open "$mfe(directory)/tmp_file$nf$track2$n.ewf" w]
		puts $tmp_ewf "source=$mfe(file$nf$track2$n)"
		set offset [expr $mfe(start2file$nf$track2$n)+$mfe(start1file$nf$track2$n)*60]
		puts $tmp_ewf "offset=$offset"
		puts $tmp_ewf "start-position=0"
		if {$mfe(duration2file$nf$track2$n)!= "" && $mfe(duration1file$nf$track2$n)!= ""} {
		    set duration [expr $mfe(duration2file$nf$track2$n)+$mfe(duration1file$nf$track2$n)*60]
		} else {set duration " "}
		puts $tmp_ewf "length=$duration"
		puts $tmp_ewf "looping=false"
		close $tmp_ewf
		set eca_string "$eca_string -a:file$nf$track2$n -i $mfe(directory)/tmp_file$nf$track2$n.ewf -ea:$mfe(volume$n) -epp:$mfe(pan$n) "
		set tracks_to_play 1
	    }
	if {$preview == 2} {
	    for {set en 1} {$en <= 4} {incr en} { 
		if {$mfe(effect$en$track) != "None" } {
		    if {[string match ladspa* $mfe(effect$en$track)]==1} {
			regsub ladspa_ $mfe(effect$en$track) {} current_effect
			set eca_string "$eca_string -el:$current_effect,"
		    } else {
			set eca_string "$eca_string -$mfe(effect$en$track):"
		    }	
		    for {set par 1} {$par <= $effect_param($mfe(effect$en$track)) } {incr par} { 
			if {$par>1} {set eca_string "$eca_string,"}
			set eca_string "$eca_string$mfe(effect_parameter$par$en$track)"
		    }
		}    
	    }

	} else {
	    set en $effect2
	    if {$mfe(effect$en$track) != "None" } {
		if {[string match ladspa* $mfe(effect$en$track)]==1} {
			regsub ladspa_ $mfe(effect$en$track) {} current_effect
			set eca_string "$eca_string -el:$current_effect,"
		} else {
			set eca_string "$eca_string -$mfe(effect$en$track):"
		}	
		for {set par 1} {$par <= $effect_param($mfe(effect$en$track)) } {incr par} { 
		    if {$par>1} {set eca_string "$eca_string,"}
		    set eca_string "$eca_string$mfe(effect_parameter$par$en$track)"
		}
	    }    
		
	}
    }
    }
    if {$tracks_to_play ==1} {	
	set eca_string2 " -a:all -o $mfe(device$track)"
	set eca_string "$eca_string $eca_string2"
	puts $eca_string
	set playhandle [open "|ecasound -c -r$eca_string" w]
	fconfigure $playhandle -buffering none -blocking 0
	puts $playhandle "setpos $start_time\n"
	puts $playhandle "t\n"
    } else {	
 	set stop_command 1
	messages [format "No tracks to be played or recorded"]
    }
}

proc close_effect {} {
    global mfe mfe_temp effect2 track stop_command
    set mfe(effect$effect2$track) $mfe_temp(effect$effect2$track)
    if {$stop_command == 0} {stop}
    destroy .effect$effect2$track

}

proc options {} {
    global mt_font option_value option_parameter bgcolor bgcolor2 line_number ladspa_path
    if {[winfo exists .options] != 0} {destroy .options}
    set rc_infile [open "~/.ecasoundrc" r]
    set line_number 0
    toplevel .options -bg $bgcolor
    message .options.out -bg $bgcolor -width 200 -text "Global Settings"
    pack .options.out -expand y -fill x    
    set param_side "left"
    canvas .options.canvas -width 750 -height 285
    set w [frame .options.canvas.f -bd 0]
    .options.canvas create window 0 0 -anchor nw -window $w

    while {[gets $rc_infile input_line] != -1 } {
	set temp_file($line_number) $input_line
	set current_parameter [split $input_line =] 
	set option_parameter($line_number) [lindex $current_parameter 0]
	set option_value($line_number) [lindex $current_parameter 1]
	if {[string match *ladspa* $option_parameter($line_number)] == 1} {
	    set ladspa_path $option_value($line_number)
	}


    	label $w.param$param_side$line_number -font $mt_font -text $option_parameter($line_number) -anchor w	
    	entry $w.value$param_side$line_number -bg white -width 28 -textvariable option_value($line_number)
	if {$param_side == "left"} {set param_side "right"} else {set param_side "left"} 
	incr line_number
    }
    if {$param_side == "right"} {
    	label $w.param.$param_side$line_number -font $mt_font -text " " -anchor w
	entry $w.value$param_side$line_number -textvariable option_value(last)	
    }
    for {set row_number 0} {$row_number < $line_number} {incr row_number} {
    set row_number2 [expr $row_number +1]
    grid $w.paramleft$row_number $w.valueleft$row_number $w.paramright$row_number2 $w.valueright$row_number2 -sticky w
    incr row_number
    } 
    pack .options.canvas -expand true
    button .options.ok -bg AntiqueWhite -activebackground LightPink -text Ok -command {save_options}
    button .options.cancel -bg AntiqueWhite -activebackground LightPink -text Cancel -command {destroy .options}
    pack .options.ok -padx 180 -side left
    pack .options.cancel
}

proc save_options {} {
    global option_value option_parameter line_number wave_editor ladspa_path eca_effects
    set rc_infile [open "~/.ecasoundrc" w]
    for {set row_number 0} {$row_number < $line_number} {incr row_number} {
	puts $rc_infile "$option_parameter($row_number)=$option_value($row_number)"
	if {[string match *wave-editor* $option_parameter($row_number)] == 1} {
	    regsub { } $option_value($row_number) {} current_value
	    set wave_editor $current_value
	}
	if {[string match *ladspa* $option_parameter($row_number)] == 1 && $ladspa_path != $option_value($row_number)} {
	    regsub { } $option_value($row_number) {} current_value
	    set ladspa_path $current_value
	    set eca_effects 20
	    ladspa
	}
    }
    close $rc_infile
    destroy .options
}

proc rec_properties {} {
    global mfe track_num bgcolor mixdown
    if {[winfo exists .rec_properties$track_num] != 0} {destroy .rec_properties$track_num}
    if {$mfe(track_status$track_num) != "Rec"} {
	destroy .rec_properties$track_num
	return
    }
    toplevel .rec_properties$track_num -bg $bgcolor 
    set w .rec_properties$track_num
    if {$mixdown==0} {
	label $w.text -bg $bgcolor -text "Recording Properties for track $track_num"
    } else {
	label $w.text -bg $bgcolor -text "Mixdown Properties"
    }
    menubutton $w.rec_bits -bg LightSkyBlue -activebackground LightSeaGreen -text "Bits" -relief raised -menu $w.rec_bits.type
	menu $w.rec_bits.type -tearoff 0
	    $w.rec_bits.type add radiobutton -label "Unsigned 8 bits" -variable mfe(rec_prop_bits$track_num) -value "u8"
	    $w.rec_bits.type add radiobutton -label "Signed 16 bits little endian" -variable mfe(rec_prop_bits$track_num) -value "s16_le"
	    $w.rec_bits.type add radiobutton -label "Signed 16 bits big endian" -variable mfe(rec_prop_bits$track_num) -value "s16_be"
	    $w.rec_bits.type add radiobutton -label "Signed 24 bits little endian" -variable mfe(rec_prop_bits$track_num) -value "s24_le"
    	    $w.rec_bits.type add radiobutton -label "Signed 24 bits big endian" -variable mfe(rec_prop_bits$track_num) -value "s24_be"
	    $w.rec_bits.type add radiobutton -label "Signed 32 bits little endian" -variable mfe(rec_prop_bits$track_num) -value "s32_le"
	    $w.rec_bits.type add radiobutton -label "Signed 32 bits big endian" -variable mfe(rec_prop_bits$track_num) -value "s32_be"
	    $w.rec_bits.type add radiobutton -label "Floating point 32 bits little endian" -variable mfe(rec_prop_bits$track_num) -value "f32_le"
	    $w.rec_bits.type add radiobutton -label "Floating point 32 bits big endian" -variable mfe(rec_prop_bits$track_num) -value "f32_be"
    menubutton $w.rec_channels -bg LightSkyBlue -activebackground LightSeaGreen -text "Channels" -relief raised -menu $w.rec_channels.type
	menu $w.rec_channels.type -tearoff 0
	    $w.rec_channels.type add radiobutton -label "1" -variable mfe(rec_prop_channels$track_num) -value "1"
	    $w.rec_channels.type add radiobutton -label "2" -variable mfe(rec_prop_channels$track_num) -value "2"
	    $w.rec_channels.type add radiobutton -label "3" -variable mfe(rec_prop_channels$track_num) -value "3"
	    $w.rec_channels.type add radiobutton -label "4" -variable mfe(rec_prop_channels$track_num) -value "4"
    menubutton $w.rec_srate -bg LightSkyBlue -activebackground LightSeaGreen -text "Sample Rate" -relief raised -menu $w.rec_srate.type
	menu $w.rec_srate.type -tearoff 0
	    $w.rec_srate.type add radiobutton -label "8000" -variable mfe(rec_prop_srate$track_num) -value "8000"
	    $w.rec_srate.type add radiobutton -label "11025" -variable mfe(rec_prop_srate$track_num) -value "11025"
	    $w.rec_srate.type add radiobutton -label "16000" -variable mfe(rec_prop_srate$track_num) -value "16000"
	    $w.rec_srate.type add radiobutton -label "22050" -variable mfe(rec_prop_srate$track_num) -value "22050"
	    $w.rec_srate.type add radiobutton -label "32000" -variable mfe(rec_prop_srate$track_num) -value "32000"
	    $w.rec_srate.type add radiobutton -label "44100" -variable mfe(rec_prop_srate$track_num) -value "44100"
	    $w.rec_srate.type add radiobutton -label "48000" -variable mfe(rec_prop_srate$track_num) -value "48000"
	    $w.rec_srate.type add radiobutton -label "96000" -variable mfe(rec_prop_srate$track_num) -value "96000"
    menubutton $w.rec_interl -bg LightSkyBlue -activebackground LightSeaGreen -text "Interleaved" -relief raised -menu $w.rec_interl.type
	menu $w.rec_interl.type -tearoff 0
	    $w.rec_interl.type add radiobutton -label "Interleaved" -variable mfe(rec_prop_interl$track_num) -value "i"
	    $w.rec_interl.type add radiobutton -label "Non Interleaved" -variable mfe(rec_prop_interl$track_num) -value "n"
    pack $w.text -side top	
    pack $w.rec_bits -side left	
    pack $w.rec_channels -side left
    pack $w.rec_srate -side left
    pack $w.rec_interl -side left
    

    if {$mixdown == 0} {
    	button $w.close -bg AntiqueWhite -activebackground LightPink -text "Close" -command "
	    destroy .rec_properties$track_num
	    return"
    } else {
    	button $w.close -bg AntiqueWhite -activebackground LightPink -text "Ok" -command "
	    file_browser2
	    play
	    destroy .rec_properties$track_num
	    return"
    }
    pack $w.close
}
############################### Main Section #################################################
# VARIABLES DESCRIPTION:
#	mt_font: Default font
#	number_of_tracks: Number of displayed tracks
#	track_number: Number of current track
#	sp_minutes: Starting position in minutes and;
#	sp_seconds: Starting position in seconds
# 	mfe(track_nameN): Name of track N
#	mfe(openfileN): Name and path of the track N wave file
# 	mfe(deviceN): Name and path of the track N audio device
# 	mfe(track_statusN): Status of track N (Could be "Play", "Rec" or "Mute")
#	mfe(effectnN): Name of effect n on track N
#	mfe(effect_parametersnN): Number of parameters of effect n on track N
#	mfe(effect_parameterPnN): Value for parameter P of effect n on track N
#	mfe(volumeN): volume of track N
#	mfe(panN): Left/Right percent
#	effect_name(nnn): A more descriptive name of the effect called nnn by ecasound
#	effect_param(nnn): Number of parameters of the effect called nnn by ecasound
#	effect_param_name(nnnN): Name of parameter N of effect called nnn by ecasound
#	effect_param_value(nnnN): Default value for parameter N of effect called nnn by ecasound
#	effect_param_from(nnnN): Begin value for parameter N of effect called nnn by ecasound
#	effect_param_to(nnnN): Ending value for parameter N of effect called nnn by ecasound
#	effect_param_resolution(nnnN): Resolution for parameter N of effect called nnn by ecasound

# Variables definition section

global mfe exit_yes track_num effect_num eca_effects
set eca_effects 20

set effect(1) "eal|Limiter|1|Limit %|0|100|100|0"
set effect(2) "ec|Compressor|2|Compression Rate (Db)|0|1|1|0|Threshold %|0|100|50|0"
set effect(3) "eca|Advanced Compressor|4|Peak Level %|0|100|69|0|Release Time (Seconds)|0|5|2|0|Fast Compressor Rate|0|1|0.5|0|Compressor Rate (Db)|0|1|1|0"
set effect(4) "enm|Noise Gate|5|Threshold Level %|0|100|100|0|Pre Hold Time (ms)|0|2000|200|0|Attack Time (ms)|0|2000|200|0|Post Hold Time (ms)|0|2000|200|0|Release Time (ms)|0|2000|200|0"
set effect(5) "ef1|Resonant Bandpass Filter|2|Center Frequency (Hz)|0|20000|0|0|Width (Hz)|0|2000|0|0"
set effect(6) "ef3|Resonant Lowpass Filter|3|Cutoff Frequency (Hz)|0|5000|0|0|Resonance|0|2|0|0|Gain|0|1|0|0"
set effect(7) "efa|Allpass Filter|2|Delay Samples|0|10000|0|0|Feedback %|0|100|50|0"
set effect(8) "efb|Bandpass Filter|2|Center Frequency (Hz)|0|11000|11000|0|Width (Hz)|0|22000|22000|0"
set effect(9) "efh|Highpass Filter|1|Cutoff Frequency (Hz)|10000|22000|10000|0"
set effect(10) "efl|Lowpass Filter|1|Cutoff Frequency (Hz)|0|10000|0|0"
set effect(11) "efr|Bandreject Filter|2|Center Frequency (Hz)|0|11000|11000|0|Width (Hz)|0|22000|22000|0"
set effect(12) "efs|Resonator Filter|2|Center Frequency (Hz)|0|11000|11000|0|Width (Hz)|0|22000|22000|0"
set effect(13) "etd|Delay|4|Delay Time (ms)|0|2000|200|0|Surround Mode (Normal, Surround St., Spread)|0|2|0|1|Number of Delays|0|100|50|0|Mix %|0|100|50|0"
set effect(14) "etc|Chorus|4|Delay Time (ms)|0|2000|200|0|Variance Time Samples|0|10000|500|0|Feedback %|0|100|50|0|LFO Frequency (Hz)|0|100|50|0"
set effect(15) "etr|Reverb|3|Delay Time (ms)|0|2000|200|0|Surround Mode (0=Normal, 1=Surround)|0|1|0|1|Feedback %|0|100|50|0"
set effect(16) "ete|Advanced Reverb|3|Room Size (Meters)|0|100|10|0|Feedback %|0|100|50|0|Wet %|0|100|50|0"
set effect(17) "etf|Fake Stereo|1|Delay Time (ms)|0|500|40|0"
set effect(18) "etl|Flanger|4|Delay Time (ms)|0|1000|200|0|Variance Time Samples|0|10000|200|0|Feedback %|0|100|50|0|LFO Frequency (Hz)|0|100|50|0"
set effect(19) "etm|Multitap Delay|3|Delay Time (ms)|0|2000|200|0|Number of Delays|0|100|20|0|Mix %|0|100|50|0"
set effect(20) "etp|Phaser|4|Delay Time (ms)|0|2000|200|0|Variance Time Samples|0|10000|100|0|Feedback %|0|100|50|0|LFO Frequency (Hz)|0|100|50|0"

set effect_index(0) "None"
for {set n 1} {$n <= $eca_effects} {incr n} {
    set current_effect [split $effect($n) |]
    set effect_index($n) [lindex $current_effect 0]
    set effect_name($effect_index($n)) [lindex $current_effect 1]
    set effect_maker($effect_index($n)) "Kai Vehmanen"
    set effect_copy($effect_index($n)) "(c) 1997-2001 Kai Vehmanen"
    set effect_param($effect_index($n)) [lindex $current_effect 2]
    set pn2 3
    for {set pn 1} {$pn <= $effect_param($effect_index($n))} {incr pn} {    
	set effect_param_name($effect_index($n)$pn) [lindex $current_effect $pn2]
	incr pn2
	set effect_param_from($effect_index($n)$pn) [lindex $current_effect $pn2]
	incr pn2				
	set effect_param_to($effect_index($n)$pn) [lindex $current_effect $pn2]
	incr pn2
	set effect_param_value($effect_index($n)$pn) [lindex $current_effect $pn2]
	incr pn2
	set effect_param_resolution($effect_index($n)$pn) [lindex $current_effect $pn2]
	incr pn2
    }
}

set ecasoundrc "~/.ecasoundrc"

if {[file exists $ecasoundrc] != 1} {
    set ecasoundrc "~/.ecasound/ecasoundrc"
}
    set rc_infile [open $ecasoundrc r]

set ladspa_path 0

while {[gets $rc_infile input_line] != -1 } {
    set current_line [split $input_line =] 
    set current_parameter [lindex $current_line 0]
    set current_value [lindex $current_line 1]
    if {[string match *ladspa* $current_parameter] == 1} {
	regsub { } $current_value {} current_value
	set ladspa_path $current_value
    }
    if {[string match *wave-editor* $current_parameter] == 1} {
	regsub { } $current_value {} current_value
	set wave_editor $current_value
    }
}

if {[string match */* $ladspa_path] == 1 || [string match /* $ladspa_path] == 1} {ladspa} else {puts "No LADSPA Support"}

set bgcolor cyan3

frame .mfe -bg $bgcolor
frame .mfe.up1 -bg $bgcolor
frame .mfe.up2 -bg cyan
frame .mfe.header -bd 6 -bg $bgcolor 
frame .mfe.tracks
frame .mfe.low -bd 6 -bg $bgcolor

set row 1
set number_of_tracks 0
set toprocess " "

set mt_font [font create -family Helvetica -size 10 -weight normal]

set play_stop "Play/Stop"
set play_command "play"
set mixdown 0
set export_ecs 0
set stop_position 0
set mfe(directory) "."
label .mfe.up1.title -justify left -bg $bgcolor -text "TKECA 1.0.2 - Tcl/Tk Frontend for Ecasound - 2003 Luis Pablo Gasparotto " 
label .mfe.up1.text -bg $bgcolor -text "Current Directory: "
entry .mfe.up1.entry -textvariable mfe(directory)
label .mfe.up1.text2 -bg $bgcolor -text "Current File: "
entry .mfe.up1.entry2 -state disabled -textvariable mfe(openfile0)
button .mfe.up1.button -bg AntiqueWhite -activebackground LightPink -text "Open file" -height 0 -command {set n 0 
set types {{{mfe files} {*.mfe}} {{all} {*}}}
set track_num 0
file_browser}
button .mfe.up1.save -bg AntiqueWhite -activebackground LightPink -text "Save file" -height 0 -command {
set save_as 0
save_file} 
button .mfe.up1.saveas -bg AntiqueWhite -activebackground LightPink -text "Save file as" -height 0 -command {
set types {{{mfe files} {*.mfe}} {{all} {*}}}
set track_num 0
file_browser2
save_file} 
button .mfe.up2.exportecs -bg AntiqueWhite -activebackground LightPink -text "Export .ecs" -width 12 -command {export_ecs} 
button .mfe.up2.mixdown -bg AntiqueWhite -activebackground LightPink -text "Mixdown" -width 12 -command {mixdown} 
button .mfe.up2.options -bg AntiqueWhite -activebackground LightPink -justify right -width 12 -text Options -command {options}
button .mfe.up2.addtrack -bg AntiqueWhite -activebackground LightPink -justify right -width 10 -text "Add Track" -command {
incr number_of_tracks
add_track}
button .mfe.up2.about -bg AntiqueWhite -activebackground LightPink -justify right -text "About TKECA" -command {
proc_about
}
button .mfe.up2.quit -bg AntiqueWhite -activebackground LightPink -justify right -text Quit -command {
set exit_yes 1
proc_exit
}

label .mfe.header.text1 -bg $bgcolor -text "N    "
label .mfe.header.text2 -bg $bgcolor -text "Name            "
label .mfe.header.text3 -bg $bgcolor -text "                               "
label .mfe.header.text4 -bg $bgcolor -text "Device  "
label .mfe.header.text5 -bg $bgcolor -text "Play/Rec.   "
label .mfe.header.text6 -bg $bgcolor -text "Effects                           "
label .mfe.header.text7 -bg $bgcolor -text "Pan                 "
label .mfe.header.text8 -bg $bgcolor -text "Volume                       "   

set bgcolor2 AntiqueWhite3
canvas .mfe.tracks.canvas  -bg $bgcolor2 -width 780 -height 400 -yscrollcommand [list .mfe.tracks.yscroll set]
.mfe.tracks.canvas config -scrollregion "0 0 0 100"
scrollbar .mfe.tracks.yscroll -orient vertical -width 8 -command [list .mfe.tracks.canvas yview]

pack .mfe.up1.title -side top -fill x -expand 1
pack .mfe.up1.text -side left  -fill x -expand 1
pack .mfe.up1.entry -side left  -fill x -expand 1
pack .mfe.up1.text2 -side left  -fill x -expand 1
pack .mfe.up1.entry2 -side left  -fill x -expand 1
pack .mfe.up1.button -side left  -fill x -expand 1
pack .mfe.up1.save -side left -fill x -expand 1
pack .mfe.up1.saveas -side top -fill x -expand 1
pack .mfe.up2.exportecs -side left -fill x -expand 1
pack .mfe.up2.mixdown -side left -fill x -expand 1
pack .mfe.up2.options -side left -fill x -expand 1
pack .mfe.up2.addtrack -side left -fill x -expand 1
pack .mfe.up2.about -side left -fill x -expand 1
pack .mfe.up2.quit -side left -fill x -expand 1
pack .mfe.up1 -side top -fill x -expand 1 
pack .mfe.up2 -side top -fill x -expand 1

pack .mfe.header.text1 -side left
pack .mfe.header.text2 -side left
pack .mfe.header.text3 -side left
pack .mfe.header.text4 -side left
pack .mfe.header.text5 -side left
pack .mfe.header.text6 -side left
pack .mfe.header.text7 -side left
pack .mfe.header.text8 -side left
pack .mfe.header
pack .mfe.tracks.yscroll -side right -fill y -expand 1
pack .mfe.tracks.canvas -side left -fill y -expand 1

set w [frame .mfe.tracks.canvas.f -bd 0]
.mfe.tracks.canvas create window 0 0 -anchor nw -window $w

pack .mfe

set stop_command 1
set sp_minutes 0
set sp_seconds 0
set pause "Pause"
set play_text "Play"
set fw_text "Forward 5''"
set rew_text "Rew 5''"
set rewbeg_text "Rew to the begin"

label .mfe.low.position -bg $bgcolor -text " Starting Position (mm:ss): "
entry .mfe.low.minutes -bg White -width 3 -textvariable sp_minutes
label .mfe.low.position2 -bg $bgcolor -text :
entry .mfe.low.seconds -bg White -width 5 -textvariable sp_seconds
label .mfe.low.spaces -bg $bgcolor -text "      "
label .mfe.low.record1 -bg $bgcolor -text "Record: "
checkbutton .mfe.low.record2 -width 1 -bg $bgcolor -variable recording -onvalue 1 -offvalue 0

button .mfe.low.play -bg AntiqueWhite -activebackground LightPink -textvariable play_text -height 0 -command { 
    if {$stop_command == 1} { 
	set stop_command 0
	set play_text "Stop"
	set fw_text " "
	set rew_text " "
	set rewbeg_text " "
	play } else {
	set stop_command 1
	set play_text "Play"
	set fw_text "Forward 5''"
	set rew_text "Rew 5''"
	set rewbeg_text "Rew to the begin"
	stop 
    }
} 

button .mfe.low.pause -bg AntiqueWhite -activebackground LightPink -textvariable pause -height 0 -command { 
    if {$stop_command == 0} {pause}
} 

button .mfe.low.rew_to_begin -bg AntiqueWhite -activebackground LightPink -textvariable rewbeg_text  -height 0 -command { 
    if {$stop_command == 1} { 
	set sp_minutes 0	 
	set sp_seconds 0	 
    }
} 

button .mfe.low.rew_5 -bg AntiqueWhite -activebackground LightPink -textvariable rew_text -height 0 -command { 
    if {$stop_command == 1} { 
	set starting_time [expr $sp_seconds+$sp_minutes*60]
	if {$starting_time > 5} {
	    set starting_time [expr $starting_time-5]
	    set sp_minutes [expr $starting_time/60]
	    set sp_minutes [expr int($sp_minutes)]
	    set sp_seconds [expr $starting_time-$sp_minutes*60]
	} else {
	    set sp_minutes 0	 
	    set sp_seconds 0
	}	 
    }
} 

button .mfe.low.forw_5 -bg AntiqueWhite -activebackground LightPink -textvariable fw_text -height 0 -command { 
    if {$stop_command == 1} { 
	set starting_time [expr $sp_seconds+$sp_minutes*60]
	set starting_time [expr $starting_time+5]
	set sp_minutes [expr $starting_time/60]
	set sp_minutes [expr int($sp_minutes)]
	set sp_seconds [expr $starting_time-$sp_minutes*60]
    }
} 

pack .mfe.tracks -side top
pack .mfe.low.position -side left
pack .mfe.low.minutes -side left
pack .mfe.low.position2 -side left
pack .mfe.low.seconds -side left
pack .mfe.low.spaces -side left
pack .mfe.low.record1 -side left
pack .mfe.low.record2 -side left
pack .mfe.low.play -side left -fill x -expand 1
pack .mfe.low.pause -side left -fill x -expand 1
pack .mfe.low.rew_to_begin -side left -fill x -expand 1
pack .mfe.low.rew_5 -side left -fill x -expand 1
pack .mfe.low.forw_5 -side left -fill x -expand 1
pack .mfe.low -fill both -expand 1
pack .mfe

